#!/bin/sh
#
# Revised - Tues, May 29, 2007
# 
# This script sets owner, group & permissions to radmind directory
#
# Copyright (c) 2007 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
#
# Recursively change owner to root & group to radmind
/usr/sbin/chown -R root:radmind /var/radmind

# Set Owner & Group to read, write & execute permissions & others to no permissions
/bin/chmod 770 /var/radmind/config

# Recursively change permissions owner & group with read & write permissions.
# Using the "X" special bit, you can make sure only directories are given execute permissions.

/bin/chmod -R ug+rwX /var/radmind/backup/
/bin/chmod -R ug+rwX /var/radmind/command/
/bin/chmod -R ug+rwX /var/radmind/file/
/bin/chmod -R ug+rwX /var/radmind/special/
/bin/chmod -R ug+rwX /var/radmind/tmp/file/
/bin/chmod -R ug+rwX /var/radmind/tmp/transcript/
/bin/chmod -R ug+rwX /var/radmind/transcript/

/bin/chmod 640 /var/radmind/overload_catalog
/usr/bin/chgrp radmind /var/log/system.log
