#!/usr/bin/perl

my @email_message;
my ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,$blksize,$blocks) = stat("/var/radmind/config");
sleep 1;

my $xhooks_radmind_reboot_file_temp = "/var/radmind/command/xhooks/radmind_reboot_temp.conf";
my $xhooks_radmind_reboot_file_real = "/var/radmind/command/xhooks/radmind_reboot.conf";
my $email_add = 'you@example.com';

if ( $mtime > time - 20 ) {

  # Start email log; beginning timestamps
  push(@email_message, localtime(time) . ": radmind_config_updater.pl activated\n\n");
  push(@email_message, "The config file changed.\n");

  $output = `grep NIGHTLY_RADMIND_REBOOT /var/radmind/config > $xhooks_radmind_reboot_file_temp 2>&1`;
  my $differences_found = "There was a problem with the diff";
  if ( ! -e $xhooks_radmind_reboot_file_temp ) {
    push(@email_message, "$xhooks_radmind_reboot_file_temp was not created by the grep command...\n\n");
  } elsif ( ! -s $xhooks_radmind_reboot_file_temp ) {
    push(@email_message, "$xhooks_radmind_reboot_file_temp has a zero size...\n\n");
  } else {
    if ( -e $xhooks_radmind_reboot_file_real ) {
      $differences_found = `diff $xhooks_radmind_reboot_file_real $xhooks_radmind_reboot_file_temp`;
      #chomp $differences_found;
      $differences_found =~ s/\n/\n\t/g;
    } else {
      push(@email_message, "$xhooks_radmind_reboot_file_real doesn't exist.\n\n");
    }
  }

  if ( $differences_found ne '' ) {
    push(@email_message, "The settings for radmind_reboot.conf changed:\n$differences_found\n\n");

    roll_log( $xhooks_radmind_reboot_file_real, 5 );
    system "mv -f $xhooks_radmind_reboot_file_temp $xhooks_radmind_reboot_file_real";

    if ( ! -e $xhooks_radmind_reboot_file_real ) {
      system "touch", $xhooks_radmind_reboot_file_real;
      push(@email_message, "$xhooks_radmind_reboot_file_real didn't get created right, so I'm creating a blank version\n");
    }

    email_status();
    sleep 10;
  }
}

sub email_status {
	push(@email_message, localtime(time) . ": radmind_config_updater.pl finished\n\n");
	my $systemMailCommand = "echo \"@email_message\" | mail -s \"radmind_config_updater.pl\" \"$email_add\"";
	system $systemMailCommand;
}

sub roll_log {
  my ($path_to_log, $number_of_backups) = @_;
  if (-e $path_to_log) {
    if (-e $path_to_log.".bak$number_of_backups") {
      unlink $path_to_log.".bak$number_of_backups";
    }
    for ($i = $number_of_backups ; $i > 1 ; $i-- ) {
      if (-f $path_to_log.".bak".($i-1)) {
        system "/bin/mv -f \"$path_to_log".".bak".($i-1)."\" \"$path_to_log".".bak$i\"";
      }
    }
    system "/bin/mv -f \"$path_to_log\" \"$path_to_log".".bak1\"";
  }
}
