/* AppControler.h */

/*
 Copyright (c) 2005 University of Utah Student Computing Labs.
 All Rights Reserved.

 Permission to use, copy, modify, and distribute this software and
 its documentation for any purpose and without fee is hereby granted,
 provided that the above copyright notice appears in all copies and
 that both that copyright notice and this permission notice appear
 in supporting documentation, and that the name of The University
 of Utah not be used in advertising or publicity pertaining to
 distribution of the software without specific, written prior
 permission. This software is supplied as is without expressed or
 implied warranties of any kind.
*/

#import <Cocoa/Cocoa.h>

@interface AppController : NSObject {

    IBOutlet NSMenu *theMenu;
    IBOutlet NSWindow *logoutWindow;
    IBOutlet NSWindow *editPrefsWindow;
    IBOutlet NSWindow *resetWindow;
    IBOutlet NSTextField *logoutTimerField;
    IBOutlet NSButton *logoutButton;
    IBOutlet NSButton *logoutCancelButton;
    IBOutlet NSButton *resetButton;
    IBOutlet NSButton *resetCancelButton;
    IBOutlet NSTextField *resetTimerField;

    //the status item that will be added to the system status bar
    NSStatusItem *statusItem;
    NSTimer *logoutTimer;
    NSTimer *resetTimer;

}

- (IBAction)logout:(id)sender;
- (IBAction)cancelLogout:(id)sender;
- (IBAction)reset:(id)sender;
- (IBAction)cancelReset:(id)sender;
- (IBAction)cancelEditPrefs:(id)sender;

@end

