#!/usr/bin/perl -w

#
# Copyright (c) 2007 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
#

my $pathToScreenPreserver = "/usr/local/bin/Screen Preserver.app/Contents/MacOS/Screen Preserver";
my $qtplay = "/usr/local/bin/qtplay";
my $musicFolder = "/Library/Preferences/Xhooks/edu.utah.scl.logoutsaver.music";
my $prefFile = "/Library/Preferences/Xhooks/edu.utah.scl.logoutsaver";
my $stopScreensaverTrigger = "/tmp/edu.utah.scl.logoutsaver.stop";

my $screenSaverIdleTime = ReadPref($prefFile, "idleTime", 300);

while (1) {
  if ( idleTime() > $screenSaverIdleTime ) {

    if ( ! -e $stopScreensaverTrigger ) {
      # Play music stuff is in here just in case someone needs to turn it off via ARD, you know...
      my $playMusic = ReadPref($prefFile, "playMusic", 0);
      if ( ! -d $musicFolder ) {
        $playMusic = 0;
      }

      if ( $playMusic ) {
        system "\"$qtplay\" -l -Z -r \"$musicFolder\" &"; # detach qtplay
      }

      system "\"$pathToScreenPreserver\"";
      # Waits until the screensaver finishes

      if ( $playMusic ) {
        system "/usr/bin/killall qtplay"; # this should really kill via pid...
      }
    } else {
      sleep 30;
    }


  } else {

    sleep $screenSaverIdleTime - idleTime() + 1;

  }
}

sub ReadPref {
  chomp ( $v=`/usr/bin/defaults read \"$_[0]\" \"$_[1]\" 2>/dev/null` );
  if ( $v eq "" and defined $_[2] ) {
    return $_[2];
  } else {
    return $v;
  }
}

sub idleTime {
  foreach (`/usr/sbin/ioreg -c IOHIDSystem`) {
    if( /HIDIdleTime" = (\d*)/ ) {
      return $1/1000000000 if $1 ne "";
    }
  }
  return 0; # just in case
}
