#!/usr/bin/perl

################################################################################
# Copyright (c) 2005 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
################################################################################

use lib "/Library/Xhooks/Modules";
require "xhooks/lib/config.pl";

my $shadow_classic_dmg = "/Library/Classic/Classic.dmg";
my $shadow_classic_mount = "/Volumes/Classic";

################################################################################
#
# Creates shadow classic startup
#
################################################################################

$osnum_sht = get_short_os_version();

if ( $osnum_sht ne "10.4" ) {
  die "ERROR: Shadow Classic only works with 10.4";
}

$classicstartuploc="/System/Library/CoreServices/Classic Startup.app/Contents/MacOS/Classic Startup";

$classicstartuprealloc="/System/Library/CoreServices/Classic Startup.app/Contents/MacOS/Real Classic Startup";

if ( -e $classicstartuprealloc ) {

  print "Classic Startup Real already exists.";

} else {

  system "/bin/mv \"$classicstartuploc\" \"$classicstartuprealloc\"";
  
  open ( FILEHANDLE, ">$classicstartuploc" );

  print FILEHANDLE << "EOF";
#!/bin/sh

if [ -e "$shadow_classic_dmg" -a ! -d "$shadow_classic_mount" ]; then
	/usr/bin/hdid "$shadow_classic_dmg" -shadow ~/Library/Preferences/ClassicShadow
fi
"$classicstartuprealloc"
EOF
  close ( FILEHANDLE );

  system "/bin/chmod +x \"$classicstartuploc\"";

}

exit 0;
