#!/usr/bin/perl

################################################################################
# Copyright (c) 2009 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
################################################################################

use lib "/Library/Xhooks/Modules/";
require "xhooks/lib/config.pl";

my $location_of_ncutil = "/usr/sbin/ncutil"; # version 3.1.2 (required on 10.4)
my $networksetup = "/usr/sbin/networksetup"; # Only on 10.5

################################################################################
# Turn on AppleTalk
print "Turning on AppleTalk.\n";

if ( get_short_os_version() eq "10.4" ) {
  if ( -e $location_of_ncutil ) {
    system $location_of_ncutil, "setprop", "/Automatic/Built-in Ethernet/AppleTalk", "method", "Node";
    system $location_of_ncutil, "--apply-on-exit", "destroyprop", "/Automatic/Built-in Ethernet/AppleTalk", "inactive";
  } else {
    print "ERROR: $location_of_ncutil is missing.\n";
  }
} else {
  if ( -e $networksetup ) {
    system $networksetup, "-setappletalk", "Ethernet", "on";
  } else {
    print "ERROR: $networksetup is missing.\n";
  }
}

