#!/usr/bin/perl

################################################################################
# Copyright (c) 2005 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
################################################################################

use lib "/Library/Xhooks/Modules";
require "xhooks/lib/config.pl";

my $computer_names = "/Library/Preferences/Xhooks/computer_names";

# This script sets the computer name.  You can set the name with the xhooks var
# COMPUTER_NAME (put it in a command file) or just leave it blank and the computer
# name will be set to the first part of the DNS name.

my $seconds_to_wait_for_network = 60;

################################################################################
# Change computer name
#
my $computer_name = "";

$computer_name = $COMPUTER_NAME if nonempty_var( $COMPUTER_NAME );

if ( $computer_name eq "" ) {

  foreach ( 1..$seconds_to_wait_for_network ) {
    my $hostname = `hostname -s`;
    chomp $hostname;
    $computer_name = $hostname;
    if ( $hostname =~ /^local./ or $hostname =~ /^localhost/ ) {
      sleep 1;
    } else {
      last;
    }
  }

}

print "Setting computer name to $computer_name.\n" if ( defined $ENV{'xhooks_verbose'} and $ENV{'xhooks_verbose'});

system "/usr/sbin/scutil", "--set", "LocalHostName", $computer_name;

$computer_name .= "_" if -e $radmind_error_file;
system "/usr/sbin/scutil", "--set", "ComputerName", $computer_name;

exit 0;
