#!/usr/bin/perl

################################################################################
# Copyright (c) 2008 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
################################################################################

# You might want to turn this off if you have custom windowserver prefs, (multiple 
# monitor prefs) because the logouthook deletes the windowserver pref at logout.

# load config file
use lib "/Library/Xhooks/Modules";
require "edu.utah.scl.display/display_conf.pl";

if ( ! defined $DISPLAY_RESOLUTION or $DISPLAY_RESOLUTION eq "" ) {
  print STDERR "ERROR $0 - The variable DISPLAY_RESOLUTION was not defined.\n";
  exit 1;
}

# Not sure if this is still needed (I can't remember if it was 10.4 or 10.3 that required it).
if ( -e "/Library/Preferences/com.apple.windowserver.plist" ) {
	print "$0 - rm /Library/Preferences/com.apple.windowserver.plist\n" if ( defined $ENV{'xhooks_verbose'} and $ENV{'xhooks_verbose'});
	unlink "/Library/Preferences/com.apple.windowserver.plist";
}

print "$0 - /usr/local/bin/SetDisplay $DISPLAY_RESOLUTION\n" if ( defined $ENV{'xhooks_verbose'} and $ENV{'xhooks_verbose'});
system "/usr/local/bin/SetDisplay $DISPLAY_RESOLUTION";

print "$0 - /usr/local/bin/display-brightness 1\n" if ( defined $ENV{'xhooks_verbose'} and $ENV{'xhooks_verbose'});
system "/usr/local/bin/display-brightness", 1;

exit 0;
