if ( -f "/Library/Preferences/Xhooks/edu.utah.scl.radmind_xhooks_conf.perl" ) {
  use lib "/Library/Preferences/Xhooks";
  require "edu.utah.scl.radmind_xhooks_conf.perl";
}

if ( defined $DISPLAY and $DISPLAY ne "" ) {
	$DISPLAY =~ s/_/ /g;
	$DISPLAY_RESOLUTION = $DISPLAY;
}

if ( ! defined $DISPLAY_RESOLUTION or $DISPLAY_RESOLUTION eq "" ) {

	%cpu_model_resolutions = (	
		'Macmini1,1'	=> '1024 768 32 60',	# Mac mini (Early 2006)
		'iMac4,1'		=> '1440 900 32 60',	# 17 inch Intel iMac (Early 2006)
		'iMac4,2'		=> '1440 900 32 60',	# ? inch Intel iMac (Mid 2006)
		'iMac5,1'		=> '1680 1050 32 60',	# 20 inch Intel iMac
		'iMac7,1'		=> '1680 1050 32 60',	# 20 inch Intel iMac
		'iMac8,1'		=> '1920 1200 32 60',	# 24 inch Intel iMac
		'MacPro1,1'		=> '1280 1024 32 60',	# Mac Pro
		'PowerMac3,1'	=> '1024 768 32 60',	# G4 (AGP-Graphics)
		'PowerMac3,2'	=> '1024 768 32 60',	# G4 (AGP-Graphics)
		'PowerMac3,3'	=> '1024 768 32 60',	# G4 (Gigabit Ethernet)
		'PowerMac3,4'	=> '1024 768 32 60',	# G4 (Digital Audio)
		'PowerMac3,5'	=> '1024 768 32 60',	# G4 (Quick Silver)
		'PowerMac3,6'	=> '1024 768 32 60',	# G4 (Mirrored Drive Doors/FW800)
		'PowerMac4,2'	=> '1024 768 32 60',	# 15 inch G4 iMac
		'PowerMac4,4'	=> '1024 768 32 60',	# eMac (ATI Graphics), (1 GHz G4)
		'PowerMac4,5'	=> '1440 900 32 60',	# 17 inch G4 iMac
		'PowerMac5,1'	=> '1024 768 32 60',	# G4 Cube
		'PowerMac6,1'	=> '1024 768 32 60',	# ? inch G4 iMac (USB 2.0)
		'PowerMac6,3'	=> '1680 1050 32 60',	# 20 inch G4 iMac
		'PowerMac6,4'	=> '1024 768 32 60',	# eMac (USB 2.0), (2005)
		'PowerMac7,2'	=> '1280 1024 32 60',	# G5 tower (June 2004?), (Early 2005, dual 2.0 + 2.3 GHz)
		'PowerMac7,3'	=> '1280 1024 32 60',	# G5 tower (June 2004), (Early 2005, dual 2.7 GHz)
		'PowerMac8,1'	=> '1440 900 32 60',	# ? inch G5 iMac
		'PowerMac8,2'	=> '1440 900 32 60',	# 17 inch G5 iMac (Ambient Light Sensor)
		'PowerMac9,1'	=> '1440 900 32 60',	# G5 tower (Late 2004)
		'PowerMac10,1'	=> '1024 768 32 60',	# Mac mini
		'PowerMac10,2'	=> '1024 768 32 60',	# Mac mini (Late 2005)
		'PowerMac11,2'	=> '1280 1024 32 60',	# G5 tower (Late 2005)
		'PowerMac12,1'	=> '1440 900 32 60',	# 17 inch G5 iMac (iSight)
	);
	
	chomp ( $model = `system_profiler SPHardwareDataType | egrep "Model Identifier|Machine Model" | awk '{ print \$3}'` );
	
	if ( defined $cpu_model_resolutions{$model} ) {
		$DISPLAY_RESOLUTION = $cpu_model_resolutions{$model};
	} else {
		print "ERROR $0 - DISPLAY_RESOLUTION was not defined and this computer model (\"$model\") did not have a default resolution.\n";
	}

}

1;
