#!/usr/bin/perl

################################################################################
# Copyright (c) 2005 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
################################################################################

use lib "/Library/Xhooks/Modules/";
require "xhooks/lib/config.pl";

die "ERROR: No username specified!" if ! defined $ARGV[0];

my $debug = 0;

$assimilate_user_script = "/Library/Xhooks/Modules/edu.utah.scl.home_folder/assimilateUser.pl";

my $theuser = $ARGV[0];
my @user_record = getpwnam( $theuser );
my $system_homefolder = $user_record[7];
print "$system_homefolder\n" if $debug;

die "ERROR system_homefolder is empty! (getpwnam didn't return a home dir)." if $system_homefolder eq "";

if ( $system_homefolder eq $userHomeFolder or $system_homefolder eq $userHomeFolder . "/" ) {
  print "$assimilate_user_script $theuser\n" if $debug;
  system $assimilate_user_script, $theuser;
} else {
  my $user_uid = $user_record[2];
  print "$user_uid $CREATE_UNMANAGED_HOME_FOLDER_IF_MISSING\n" if $debug;
  if ( true_var( $CREATE_UNMANAGED_HOME_FOLDER_IF_MISSING ) and $user_uid >= 1000 and ! -e "$system_homefolder/.username" ) {
    print "$assimilate_user_script $theuser $system_homefolder 1\n" if $debug;
    system $assimilate_user_script, $theuser, $system_homefolder, "1";
  } else {
    print "LIL_1_assimilate.pl ERROR: The user's ($theuser) home folder specified by xhooks ($userHomeFolder) is not the same as specified by the system ($system_homefolder)!";
  }
}

exit 0;
