#!/usr/bin/perl

################################################################################
# Copyright (c) 2005 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
################################################################################

use lib "/Library/Xhooks/Modules/";
require "xhooks/lib/config.pl";

################################################################################
# Create Menubar prefs
#
if ( defined @SYSTEM_MENUBAR_ITEMS and $#SYSTEM_MENUBAR_ITEMS >= 0 ) {
  create_menubar_prefs( $template_homefolder );
  create_menubar_prefs( $adminUserHomeFolder );
  entman_logger ( "log drawer", "Menubar prefs written." );
} else {
  entman_logger ( "log drawer", "ERROR: There are no menubar items." );
}

sub create_menubar_prefs {
  my ( $home_folder ) = @_;
  
  my $menuprefs = "$home_folder/Library/Preferences/com.apple.systemuiserver.plist";
  
  if ( ! -d "$home_folder/Library/Preferences" ) {
    entman_logger ( "log drawer", "The folder $home_folder/Library/Preferences does not exist." );
    return;
  }
  
  
  entman_logger ( "log drawer", "Creating $menuprefs." );
  
  open ( FILEHANDLE, ">$menuprefs" );

  print FILEHANDLE     '<?xml version="1.0" encoding="UTF-8"?>';
  print FILEHANDLE     '<!DOCTYPE plist PUBLIC "-//Apple Computer//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">';
  print FILEHANDLE     '<plist version="1.0">';
  print FILEHANDLE     '<dict>';
  print FILEHANDLE     '        <key>menuExtras</key>';
  print FILEHANDLE     '        <array>';
  foreach $menubar_item ( @SYSTEM_MENUBAR_ITEMS ) {
    print FILEHANDLE   "                <string>$menubar_item</string>";
  }
  print FILEHANDLE     '        </array>';
  print FILEHANDLE     '</dict>';
  print FILEHANDLE     '</plist>';

  close ( FILEHANDLE );

  system "/usr/bin/plutil -convert binary1 \"$menuprefs\"";

}
