#!/usr/bin/perl

################################################################################
# Copyright (c) 2008 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
################################################################################

use lib "/Library/Xhooks/Modules/";
require "xhooks/lib/config.pl";

$idle_delay = 240;

$needsMoreHomeFolders = 1;
$trashNeedsCleaning = 1;
$create_cached_home_folders_script = "/Library/Xhooks/Modules/edu.utah.scl.home_folder/create_cached_home_folders.pl";

my $wait_for_radmind = "/var/log/wait_for_radmind";

my $debug = 0;
$debug = 1 if defined $ARGV[0];

print "debugging\n" if $debug;


while ( 1 ) {
  if ( ! -e $wait_for_radmind ) {
    my $idleTime = idleTime();
    if ( $idleTime > $idle_delay ) {
      if ( $needsMoreHomeFolders ) {
        print "I need a home folder\n" if $debug;
        home_folder_management();
      } elsif ( $trashNeedsCleaning ) {
        print "Emptying trash\n" if $debug;
        empty_trash();
        $trashNeedsCleaning = 0;
      } else {
        # all done with everything
        print "All done, sleeping $idle_delay\n" if $debug;
        sleep $idle_delay;
      }
    } else {
      $trashNeedsCleaning = 1;
      $needsMoreHomeFolders = 1;

      my $pause_time = $idle_delay - $idleTime + 1;
      $pause_time = ( $pause_time > 0 ) ? $pause_time : 0;
      print "Not idle, sleeping $pause_time ($idle_delay - $idleTime + 1)\n" if $debug;
      sleep $pause_time;
    }
  } else {
    print "$wait_for_radmind exists, waiting 60 seconds\n" if $debug;
    sleep 60; # 1 minute
  }  
}

sub home_folder_management {
  # Ideally make this detached process (I believe it isn't currently)
  $currentHomeFolders = count_home_folder_cache_folders();
  if ( $currentHomeFolders < 10 ) {
    $currentHomeFoldersPlus1 = $currentHomeFolders + 1;
    print "\"$create_cached_home_folders_script\" $currentHomeFoldersPlus1\n" if $debug;
    system "\"$create_cached_home_folders_script\" $currentHomeFoldersPlus1";
  } else {
    print "No more home folders needed.\n" if $debug;
    $needsMoreHomeFolders = 0;
  }
}

