#!/usr/bin/perl -w

# don't forget to get idlescript_availability.pl working

################################################################################
#
# Copyright (c) 2009 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
#
################################################################################

use lib "/Library/Xhooks/Modules";
require "xhooks/lib/config.pl";

my $timeTillNextCheck = 3; # wait this many seconds before iterating the main event loop
my $timeToDelayCleanup = 10; # give the user this many seconds to deactive screen saver and cancel cleanup

my $cleanup_trigger = "/tmp/cleanup_kiosk";
my $logout_trigger_file = "/tmp/logoutNow";
my $logoutNowScript = "/Library/Xhooks/Modules/edu.utah.scl.kiosk/logoutnow.scpt";
my $run_startup_post_maintenance = "/Library/Preferences/Xhooks/triggerfiles/run_startup_post_maintenance";
my $radmind_finished = "/Library/Preferences/Xhooks/triggerfiles/radmind_finished";
my $wait_for_radmind = "/var/log/wait_for_radmind";
my $make_browser_window_big_trigger = "/Library/Preferences/Xhooks/triggerfiles/make_browser_window_big";
my $assimilate_user_script = "/Library/Xhooks/Modules/edu.utah.scl.home_folder/assimilateUser.pl";
my $killsumapps = "/Library/Xhooks/Modules/edu.utah.scl.watchfolder/killsumapps.pl";
my $rightNow;
my $debug = ( defined $ARGV[0] ) ? 1 : 0;

print "Debug mode\n" if $debug;

my $current_username = getUsername();
my $die_counter = 0;
while ( $current_username eq "" ) {
  $current_username = getUsername();
  sleep 2;
  $die_counter++;
  die "Could not get username" if $die_counter > 100;
}

#############################################
# RUN
my $needsCleanUp = 1;
my $timeSinceLastCleanUp = 0;
my $timeThisScriptStarted = time;
my $screenSaverHasActivated = 0;

while ( 1 ) {

  # CHECK FOR THINGS THAT STOP NORMAL OPPERATING PROCEDURES...
  if ( ! -e $radmind_finished or -e $run_startup_post_maintenance or -e $logout_trigger_file or -e $wait_for_radmind ) {
    print "Stopped: ! -e $radmind_finished or -e $run_startup_post_maintenance or -e $logout_trigger_file or -e $wait_for_radmind\n" if $debug;
    sleep $timeTillNextCheck;
    next;
  }

  ######################################
  ## NORMAL OPERATING PROCEEDURES FOLLOW
  ######################################

  if ( -e $cleanup_trigger ) {
    cleanup();
  }

  if ( isThisAppRunning( "ScreenSaverEngine", $current_username ) ) {
    $screenSaverHasActivated = 1;
    if ( true_var( $AUTOLOGIN ) ) {
      $AUTOLOGIN = $AUTOLOGIN;
      # clean up
      if ( $needsCleanUp ) {
        
        $rightNow = time;
        if ( $timeSinceLastCleanUp == 0 ) {
          $timeSinceLastCleanUp = $rightNow;
          print "Needs clean up\n" if $debug;
        } elsif ( $rightNow - $timeSinceLastCleanUp > $timeToDelayCleanup ) {
          cleanup();
        } elsif ( $debug ) {
          print "Waiting to do cleanup\n" if $debug;
        }
      }
    } else {

      print "Logging out\n" if $debug;

      # log me out.
      print "$killsumapps $current_username\n" if $debug;
      system $killsumapps, $current_username;
      print "/usr/bin/touch $logout_trigger_file\n" if $debug;
      system "/usr/bin/touch", $logout_trigger_file;
      print "/usr/bin/osascript $logoutNowScript\n" if $debug;
      system "/usr/bin/osascript", $logoutNowScript;

    }
  } else {

    print "Screen saver not active\n" if $debug;

    if ( $screenSaverHasActivated ) {

      print "Activity detected (screensaver went away)\n" if $debug;
      $needsCleanUp = 1;
    
    } else {
      $rightNow = time;
      my $time_difference = abs ( $rightNow - $timeThisScriptStarted - idleTime() );
      print "difference in idletime and login time $time_difference\n" if $debug;
      if ( $time_difference < 10 ) {
        print "Me thinks the computer just logged in, so do nothing\n" if $debug;
      } else {
        print "Activity detected (idle time is less than the time this script has been alive)\n" if $debug;
        $needsCleanUp = 1;

      }
    }
  }
  sleep $timeTillNextCheck;
}

sub cleanup {
  print "Cleaning up\n" if $debug;
  system $assimilate_user_script, $current_username;
  sleep 3;
  system $killsumapps, $current_username;
  
  $needsCleanUp = 0;
  $timeSinceLastCleanUp = 0;
  system "touch $make_browser_window_big_trigger";
}
