#!/usr/bin/perl

################################################################################
# Copyright (c) 2005 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
################################################################################

use Foundation;
use lib "/Library/Xhooks/Modules/";
require "xhooks/lib/perlplist.pl";

################################################################################
# SLD_turn_on_local_mcx.pl
#
# This script turns on local mcx settings.
#
################################################################################

my $debug = 1;

my $path_to_computer_file = "/Library/Xhooks/Modules/edu.utah.scl.local_mcx/local_machine.plist";
my $path_to_move_computer_file_to = "/var/db/dslocal/nodes/Default/computers/local_machine.plist";

$_ = `ifconfig en0 | grep ether`;

m/(..:..:..:..:..:..)/;
my $ethernet_address = $1;

print "Ethernet Address: \"$ethernet_address\"\n" if $debug == 1;

if ( -e $path_to_computer_file ) {
	$dict = loadDefaults( $path_to_computer_file );
} else {
	die "$path_to_computer_file does not exist";
}

setPlistObject( $dict, "en_address", 0, $ethernet_address);
saveDefaults( $dict, $path_to_move_computer_file_to );

exit 0;
