#!/usr/bin/perl

################################################################################
# Copyright (c) 2008 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
################################################################################

################################################################################

# GET OS VERSION (this must be done first)
my $osnum = `sw_vers | grep ProductVersion | awk '{print \$2}'`;
chomp $osnum;
my $osnum_short = $osnum;
$osnum_short =~ s/(\d+\.\d+).*/$1/;

die "Couldn't get OS version!" if $osnum eq "" or $osnum_short eq "";

my $core_services = "/System/Library/CoreServices";
my $basepath = "/Library/Preferences/Xhooks/edu.utah.scl.loginpanel/${osnum_short}";

################################################################################

# CHANGE THE FOLLOWING IF YOU DON'T USE THE NAMES PROVIDED
#
# THESE ARE ALL FILES THAT YOU NEED TO CREATE!
#
my $login_nib_username_template = "$basepath/NameAndPassword.nib/keyedobjects.nib";
my $login_nib_username_new = "$core_services/SecurityAgentPlugins/loginwindow.bundle/Contents/Resources/English.lproj/NameAndPassword.nib/keyedobjects.nib";

################################################################################

use lib "/Library/Xhooks/Modules/";
require "xhooks/lib/config.pl";

################################################################################
# Change the nib w/ username and password fields

if ( `/usr/bin/diff \"$login_nib_username_template\" \"$login_nib_username_new\"` ) {

  if ( ! -e "${login_nib_username_new}.bkup" ) {
    system "/bin/mv \"$login_nib_username_new\" \"${login_nib_username_new}.bkup\"";
    #print "/bin/mv \"$login_nib_username_new\" \"${login_nib_username_new}.bkup\"\n";
  }

  if ( -e $login_nib_username_template ) {

    system "/bin/cp \"$login_nib_username_template\" \"$login_nib_username_new\"";
    #print "/bin/cp \"$login_nib_username_template\" \"$login_nib_username_new\"\n";

    system "/bin/chmod 644 \"$login_nib_username_new\"";
    system "/usr/sbin/chown 0:0 \"$login_nib_username_new\"";

  } else {
    entman_logger ( "log", "file $login_nib_username_template missing." );
  }

} else {
  entman_logger ( "log", "Not modifying the username field nib." );
}

entman_logger ( "log", "Done." );

exit 0;
