#!/bin/sh
# This script will attempt to unmount and eject all disks not
# listed in $ejectexclude.  $ejectexclude must be present even if
# it is empty.  This should be run as root.
#
# $ejectexclude examples lines:
#
# "^disk0" will exclude the boot disk
#
# "^disk[0-9][0-9]*[a-zA-Z]" will exclude all partitions, only ejecting disks

PATH=/bin:/usr/bin:/usr/sbin; export PATH

ejectexclude=/Library/Preferences/Xhooks/ejectexclude

if [ ! -f $ejectexclude ];then
   	echo No exclude list: "$ejectexclude"
   	exit 1
fi

cd /dev
for disk in `ls disk* | egrep -v -f "$ejectexclude"`; do
   	echo Ejecting "$disk"
   	hdiutil eject -quiet -force "$disk"
done

exit 0
