#!/usr/bin/perl

################################################################################
# Copyright (c) 2008 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
################################################################################

# This script will run radmind if a set username logs in. It will also reboot to 
# prevent that user from ever logging in (it shouldn't be able to, ever). Beware!

if ( -f "/Library/Preferences/Xhooks/edu.utah.scl.radmind_xhooks_conf.perl" ) {
	use lib "/Library/Preferences/Xhooks";
	require "edu.utah.scl.radmind_xhooks_conf.perl";
} else {
	die "ERROR $0 - The file /Library/Preferences/Xhooks/edu.utah.scl.radmind_xhooks_conf.perl is missing and this script requires it!\n";
}
if ( ! defined $ARGV[0] ) {
	die "ERROR $0 - I don't know the username (ARGV[0] was not defined).";
}
if ( ! defined $RADMIND_USER_NAME or $RADMIND_USER_NAME eq "" ) {
	die "ERROR $0 - The variable RADMIND_USER_NAME was not defined.";
}

my $launch_maintenance_script = "/Library/Xhooks/Modules/edu.utah.scl.radmind/launch_maintenance";

if ( $RADMIND_USER_NAME eq $ARGV[0] ) {
	if ( defined $RADMIND_SERVERS[0] and $RADMIND_SERVERS[0] ne "" ) {
		print "$0 - $launch_maintenance_script" if ( defined $ENV{'xhooks_verbose'} and $ENV{'xhooks_verbose'});
		system "$launch_maintenance_script";
	} else {
		print "ERROR $0 - The radmind user ($RADMIND_USER_NAME) logged in but the variable \$RADMIND_SERVERS[0] is not defined, so I can't run radmind.  Rebooting.\n";
	}
	system "/sbin/reboot";
	while ( 1 ) { sleep 1; }
}

exit 0;
