#!/usr/bin/perl

################################################################################
#
# Copyright (c) 2008 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
#
################################################################################

use lib "/Library/Xhooks/Modules/";
require "xhooks/lib/config.pl";

my $run_startup_post_maintenance = "/Library/Preferences/Xhooks/triggerfiles/run_startup_post_maintenance";
my $post_maintenance_script = "/Library/Xhooks/Modules/xhooks/bin/postmaintenance.hook";

my $loginwindow_launchd = "/Library/Xhooks/Modules/xhooks/resources/com.apple.loginwindow.plist";
my $post_maintenance_launchd_path = "/Library/LaunchAgents/edu.utah.scl.postmaintenance.loginwindow.plist";
my $post_maintenance_launchd_name = "edu.utah.scl.postmaintenance.loginwindow";

################################################################################
print "$0 - started." if ( defined $ENV{'xhooks_verbose'} and $ENV{'xhooks_verbose'});

my $osnum = `sw_vers | grep ProductVersion | awk '{print \$2}'`;
$osnum =~ s/(\d+\.\d+).*\n/$1/;

if ( -e $run_startup_post_maintenance ) {

  if ( $osnum eq "10.5" ) {

    if ( ! -e "$post_maintenance_launchd_path" ) {
      die "Can not load $post_maintenance_launchd_path because it is missing.\n";
    }

	system "mv /etc/kcpassword /etc/kcpassword_disabled" if -e "/etc/kcpassword";

	if ( `launchctl list | grep com.apple.loginwindow` eq "" ) {
	    system 'launchctl', 'load', $loginwindow_launchd;
		while ( ! isThisAppRunning( "loginwindow", "root" ) ) {
			sleep 1;
		}
	}

	while ( `launchctl list | grep $post_maintenance_launchd_name` eq "" ) {
		sleep 1;
	}

	if ( system 'launchctl', 'start', $post_maintenance_launchd_name ) {
		die "Launchd could not load edu.umich.iHook.loginwindow: $!";
	}
    
    while ( 1 ) { sleep 1; } # wait forever.  I'm pretty sure I need to eventually reboot......

  } else {

    system $post_maintenance_script;

  }
}

exit 0;
