#!/usr/bin/perl

################################################################################
# Copyright (c) 2005 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
################################################################################

use lib "/Library/Xhooks/Modules/";
require "xhooks/lib/config.pl";

################################################################################
#
# This script copies files and folders that need to be replaced at every login
# from a backup.  Namely, cups settings, and files and folders that must be world
# world writable.  See PMD_replicate.pl for the half that creates the backup.
#
################################################################################

if ( defined @LOGIN_REPLICATE_ITEMS and $#LOGIN_REPLICATE_ITEMS >= 0 ) {
  foreach $item_to_replicate ( @LOGIN_REPLICATE_ITEMS ) {
    if ( -e "$writable_caches_folder/$item_to_replicate" ) {
      if ( -e $item_to_replicate ) {
        system "/usr/bin/chflags", "-R", "nouchg", "$item_to_replicate";
        system "/bin/rm", "-f", "-r", $item_to_replicate;
      }
      system "/usr/bin/ditto", "$writable_caches_folder/$item_to_replicate", "$item_to_replicate";
    }
  }
}

exit 0;
