#!/usr/bin/perl

################################################################################
# Copyright (c) 2005 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
################################################################################

use lib "/Library/Xhooks/Modules/";
require "xhooks/lib/config.pl";

################################################################################
#
# This script creates a backup of files and folders that need to be replaced at
# every login.  Namely, cups settings, and files and folders that must be world
# world writable.  See LID_replicate.pl for the half performs the copies at 
# login.
#
################################################################################

if ( defined @LOGIN_REPLICATE_ITEMS and $#LOGIN_REPLICATE_ITEMS >= 0 ) {

  entman_logger ( "log drawer", "Replicating files to be replaced at login." );

  foreach $item_to_replicate ( @LOGIN_REPLICATE_ITEMS ) {

    if ( -e $item_to_replicate ) {

      # remove old if there... (shouldn't be)
      if ( -e "$writable_caches_folder/$item_to_replicate" ) {
        entman_logger ( "log drawer", "$writable_caches_folder/$item_to_replicate already existed.. deleting." );
        system "/usr/bin/chflags -R nouchg \"$writable_caches_folder/$item_to_replicate\"";
        system "/bin/rm -rf \"$writable_caches_folder/$item_to_replicate\"";
      }

      system "/usr/bin/ditto -rsrc \"$item_to_replicate\" \"$writable_caches_folder/$item_to_replicate\"";

      entman_logger ( "log drawer", "Backed up $item_to_replicate." );

    } else {
      entman_logger ( "log drawer", "$item_to_replicate does not exist." );
    }

  }

} else {

  entman_logger ( "log drawer", "Backing world writable files disabled." );

}

entman_logger ( "log drawer", "Done replicating items." );

exit 0;
