#!/usr/bin/perl

################################################################################
# Copyright (c) 2005 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
################################################################################

use lib "/Library/Xhooks/Modules/";
require "xhooks/lib/config.pl";
require "edu.utah.scl.secure/hide_folders_files_lib.pl";

if ( ! defined $ARGV[0] ) {
  entman_logger ( "log drawer", "No username specified!" );
  exit 1;
}

my $theuser = $ARGV[0];
my $hideme = 1;
my $allow_ard = 0;
my $ur_shpeshal;

if ( defined @USERS_WITH_NO_XHOOKS_RESTRICTIONS and $#USERS_WITH_NO_XHOOKS_RESTRICTIONS >= 0 ) {
  foreach $ur_shpeshal ( @USERS_WITH_NO_XHOOKS_RESTRICTIONS ) {
    if ( $theuser eq $ur_shpeshal ) {
      $hideme = 0;
      $allow_ard = 1;
      last;
    }
  }
}

if ( $hideme ) {
  restrict_folders_files( @REMOVE_PERMISSIONS );
  hide_folders_files( @REMOVE_PERMISSIONS );
  hide_folders_files( @HIDE_FOLDERS_FILES );
} else {
  unrestrict_folders_files( @REMOVE_PERMISSIONS );
  unhide_folders_files( @REMOVE_PERMISSIONS );
  unhide_folders_files( @HIDE_FOLDERS_FILES );
}

if ( ! $allow_ard and defined @USERS_WHO_CAN_LAUNCH_ARD and $#USERS_WHO_CAN_LAUNCH_ARD >= 0 ) {
  foreach $ur_shpeshal ( @USERS_WHO_CAN_LAUNCH_ARD ) {
    if ( $theuser eq $ur_shpeshal ) {
      $allow_ard = 1;
      last;
    }
  }
}

if ( $allow_ard ) {
#  unhide_folders_files( ( "/System/Library/PreferencePanes/SharingPref.prefPane" ) );
  chmod 0755, "/System/Library/PreferencePanes/SharingPref.prefPane";
}
