#!/usr/bin/perl

################################################################################
# Copyright (c) 2005 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
################################################################################

use lib "/Library/Xhooks/Modules/";
require "xhooks/lib/config.pl";

my $openFirmwareChecksumFile = "/Library/Preferences/Xhooks/edu.utah.scl.secure/ofpwchecksum";

################################################################################
#
# nvram security-password | openssl dgst -sha1
#
################################################################################

$ofpassword  = `/usr/sbin/nvram security-mode`;
chomp $ofpassword;

if ( $ofpassword ne "security-mode\tcommand" ) {

  entman_logger ( "log", "Found a problem: no openfirmware password." );
  system "\"$remote_logger_script\" OFPW \"I do not have an OFPW set.\"";

} else {

  if ( -e $openFirmwareChecksumFile ) {

    open (FILEHANDLE, "< $openFirmwareChecksumFile");
    $ofpwCksumFile = <FILEHANDLE>;
    close (FILEHANDLE);
    chomp $ofpwCksumFile;

    $ofpwCksumReal = `nvram security-password | openssl dgst -sha1`;
    chomp $ofpwCksumReal;
    if ( $ofpwCksumFile ne $ofpwCksumReal ) {
      entman_logger ( "log", "Found a problem: open firmware password is wrong." );
      system "\"$remote_logger_script\" OFPW \"My OFPW is wrong.\"";
    }
  }
}
