#!/usr/bin/perl

################################################################################
# Copyright (c) 2005 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
################################################################################

use lib "/etc/entman/conf/";
require "entman_config.pl";
require "replicate/replicate_conf.pl";

################################################################################
# entman - modules/configure/SLD_find_writable.pl
#
# This script searches the hard disk for world writable files/folders.  There is
# an ignore list for known places that are always world writable (to reduce 
# noise)
#
################################################################################

# The following files/folders are ignored by the find writable switch (everything in 
# @login_replicate_items is added to this list also)
@find_writable_ignore_list =
( ".Trashes",
  "/.Trashes",
  "/File Transfer Folder",
  "/Library/Application Support/DataViz",
  "/Library/Application Support/SyncService",
  "/Library/Caches",
  "/Library/ColorSync/Profiles",
  "/System/Library/Caches",
  "/System/Library/User Template",
  "/Volumes",
  "/core",
  "/dev",
  "/private/tmp",
  "/private/var/run",
  "/private/var/spool/",
  "/private/var/tmp",
 );
 #"/.FBCLockFolder/.FBCSemaphoreFile",
 #"/private/var/root/Library/Caches",

if ( defined $AUTO_LONG_MAINTENANCE_HOURS ) {
  if ( $AUTO_LONG_MAINTENANCE_HOURS =~ /(\d+) (\d+)/ ) {
    if ( timewindow( $1, $2 ) ) {

      @ignore_entman_stuff = (
            "$writable_caches_folder",
            "$global_home_folder_lost_and_found",
            "$template_homefolder",
            "$homeFolderBackups",
            "/private/var/root/Library/Caches",
            "/Users/mac/Public/Drop Box",
        );

      if ( true_var ( $LOGIN_HOME_DIR ) and -e $LOGIN_HOME_DIR ) {
        push @ignore_entman_stuff, $LOGIN_HOME_DIR;
      }

      @ignoreList = ( @find_writable_ignore_list, @login_replicate_items, @ignore_entman_stuff );

      ################################################################################
      # Go
      #
      @dirs = `/usr/bin/find / ! -type l -perm -2`;

      foreach $i ( @dirs ) {
        chomp $i;
        $flag = 1;
        foreach $j ( @ignoreList ) {
          if ( index ( $i, $j ) == 0 or index ( $i, "/private$j" ) == 0 ) {
            $flag = 0;
            last;
          }
        }
        if ( $flag ) {
          push ( @final_list, $i );
        }
      }
      $size = @final_list;
      if ( $size > 0 ) {
        system "\"$remote_logger_script\" Writable \"I have writable folders @final_list.\"";
        entman_logger ( "log", "Bad news" );
      }

      entman_logger ( "log drawer", "Find writable done." );

    }
  }
}

exit 0;
