#!/usr/bin/perl

################################################################################
# Copyright (c) 2005 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
################################################################################

use lib "/Library/Xhooks/Modules/";
require "xhooks/lib/config.pl";

my $osnum_sht = get_short_os_version();

my $kernel_panic_log_file;

if ( $osnum_sht ne "10.4" ) {
  $kernel_panic_log_file = "/Library/Logs/panic.log";
} else {
  $kernel_panic_log_file = "/var/db/PanicReporter/current.panic";
}

################################################################################
# Email kernel panic log file if it exists
if ( -e $kernel_panic_log_file and nonempty_var ( $REPORT_EMAIL_ACCOUNT ) and nonempty_var ( $REPORT_EMAIL_SERVER ) ) {

  $timeStamp = getTimeStamp ( ( stat $kernel_panic_log_file )[9] );
  $timeStamp =~ s/ /_/g;

  my $new_panic_filename = "/Library/Logs/panic_${timeStamp}.log";
  system "/bin/mv $kernel_panic_log_file $new_panic_filename";

  wait_for_network();
  system "/usr/local/bin/file_emailer.pl -t $REPORT_EMAIL_ACCOUNT\@$REPORT_EMAIL_SERVER -s PanicLog -p $logfile";

}

exit 0;
