#!/usr/bin/perl

################################################################################
# Copyright (c) 2005 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
################################################################################

use lib "/Library/Xhooks/Modules/";
require "xhooks/lib/config.pl";

use Foundation;
require "xhooks/lib/perlplist.pl";

################################################################################
#
# This script writes the ard status fields
#
# Field 1: location -- helps to find wayward machines?  (use a radmind trigger file)
# Field 2: radmind status -- $ARGV[0] actually.
# Field 3: The error returned by radmind (if there was one).
# Field 4: The time this script runs (which should be close to the boot time).
#
################################################################################

my $ard_field1 = "hi";

my $ard_field2 = "$ARGV[0]";

my $ard_field3 = "";
if ( -e $radmind_error_file ) {
  $ard_field3 = `/bin/cat \"$radmind_error_file\"`;
} else {
  $ard_field3 = "No error";
}

my $ard_field4 = "Boot date: " . `/bin/date`;
chomp $ard_field4;

my $dict;

if ( -e "/Library/Preferences/com.apple.RemoteDesktop.plist" ) {
  $dict = loadDefaults( "/Library/Preferences/com.apple.RemoteDesktop.plist" );
} else {
  $dict = NSMutableDictionary->dictionary();
}

setPlistObject( $dict, "Text1", "$ard_field1" );
setPlistObject( $dict, "Text2", "$ard_field2" );
setPlistObject( $dict, "Text3", "$ard_field3" );
setPlistObject( $dict, "Text4", "$ard_field4" );

saveDefaults( $dict, "/Library/Preferences/com.apple.RemoteDesktop.plist" );

exit 0;
