#!/usr/bin/perl

################################################################################
# Copyright (c) 2005 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
################################################################################

use lib "/Library/Xhooks/Modules/";
require "xhooks/lib/config.pl";

# This script runs fsdiff and creates a transcript with all changes that are made after 
# automated radmind.  It appends this transcript to /var/radmind/client/command.K so that
# the next fsdiff you run (as long as you don't run ktcheck) will omit all changes made by
# scripts (like this one) and other OS behavior, thereby giving you a much cleaner,
# spiffier, scan.  Please remember that running ktcheck will update the command.K file and
# remove this locally created transcript from the command file.

my $force_run = ( $ARGV[0] eq "-f" ) ? 1 : 0;

my $tech_fsdiff_completed = "/Library/Preferences/Xhooks/xhooks_changes_transcript_created"; # this trigger file is used to make sure this script only finishes once.

if ( $force_run or ( ! -e $tech_fsdiff_completed and defined $AUTO_LONG_MAINTENANCE_HOURS ) ) {
  if ( $force_run or $AUTO_LONG_MAINTENANCE_HOURS =~ /(\d+) (\d+)/ ) {
    if ( $force_run or timewindow( $1, $2 ) ) {
	  system "ulimit -n 512; cd /; /usr/local/bin/fsdiff -c sha1 -C ./ > /var/radmind/client/xhook_changes.T";
	  system "echo p xhook_changes.T >> /var/radmind/client/command.K";
	  system "/usr/bin/touch \"$tech_fsdiff_completed\""; 
    }
  }
}
