#!/usr/bin/perl

################################################################################
# Copyright (c) 2005 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
################################################################################

use lib "/Library/Xhooks/Modules/";
require "xhooks/lib/config.pl";

if ( ! defined $ARGV[0] ) {
  entman_logger ( "log drawer", "No username specified!" );
  exit 1;
}

$debug = 0;
$theuser = $ARGV[0];

my %allowedApps = ();
if ( defined @DONT_KILL_AT_LOGOUT ) {
  foreach my $allow_app ( @DONT_KILL_AT_LOGOUT ) {
    $allowedApps{$allow_app} = 1;
  }
}

@runningApps = getAppsRunningRightNow( $theuser );

foreach(@runningApps) {
  $_ =~ s/(.*) -psn_\w*$/$1/;
  $_ =~ s/(.*) MDSImporterWorker com.apple.Spotlight.ImporterWorker.\d*$/$1/;
  if ( $_ =~ /\s*(\d*)\s*(.*)/ ) {
    if ( ! defined $allowedApps{$2} or ! $allowedApps{$2} ) {
      print "kill $1 ($2)\n" if $debug;
      system "kill $1" if ! $debug;
    } else {
      print "allowed $_\n" if $debug;
    }
  } else {
    print "ERROR $_\n";
  }
}

exit 0;

################################################################################
sub getAppsRunningRightNow {
  local ( $username ) = @_;
  open ( PROC, "ps wwxo pid,command -U $username |" );
  @proclist = <PROC>;
  close PROC;
  shift @proclist;
  chomp( @proclist);
  return @proclist;
}
