#!/usr/bin/perl

################################################################################
# Copyright (c) 2007 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
################################################################################

use lib "/Library/Xhooks/Modules/";
require "xhooks/lib/config.pl";

my $temp_script = 						"/private/temp_script.pl";
my $launch_maintenance_now = 			"/private/radmind";
my $launch_maintenance_now_balanced = 	"/private/radmind_balanced";
my $run_prepForOverload = 				"/private/prep";
my $logout_trigger_file = 				"/tmp/logoutNow";

my $logout_hook_running = "/Library/Preferences/Xhooks/triggerfiles/logout_hook_running";
my $logout_hook_finished = "/Library/Preferences/Xhooks/triggerfiles/logout_hook_finished";
my $run_maintenance_startup_trigger = "/Library/Preferences/Xhooks/triggerfiles/run_maintenance";
my $prepForOverload_script = "/usr/local/bin/prep_for_overload";
my $killsumapps = "/Library/Xhooks/Modules/edu.utah.scl.watchfolder/killsumapps.pl";

my $debug = 0;

my $launchd_delay = 11;

# Launch tmp script if it exists
if ( -e $temp_script ) {
  print "Found $temp_script\n" if $debug;
  system "/bin/chmod 755 \"$temp_script\"";
  system $temp_script;
  system "/bin/rm -rf \"$temp_script\"";
  exit;
}

# Launch maintenance
if ( -e $launch_maintenance_now ) {
  print "Found $launch_maintenance_now\n" if $debug;
  unlink $launch_maintenance_now;
  $run_maintenance = 1;
}

if ( -e $launch_maintenance_now_balanced ) {
  print "Found $launch_maintenance_now_balanced\n" if $debug;
  unlink $launch_maintenance_now_balanced;
  system "/usr/bin/touch \"$use_shadow_server\"";
  $run_maintenance = 1;
}

if ( $run_maintenance ) {
  print "Running Maintenance\n" if $debug;
  if ( true_var( $RADMIND_RUNS_ONLY_IF_LOGGED_OUT ) and is_machine_logged_in() ) {
    print "Didn't run radmind because computer was logged in.";
  } else {
    system "/usr/bin/touch $run_maintenance_startup_trigger";
    warn_users_of_restart();
    print "Rebooting.";
    system "/sbin/reboot";
    while ( 1 ) { sleep 10 };
  }
}

# Run prepForOverload
if ( -e $run_prepForOverload ) {
  print "Found $run_prepForOverload\n" if $debug;
  system "\"$prepForOverload_script\""; # definitely don't return
  system "/bin/rm -rf \"$run_prepForOverload\"";
  exit;
}

# Run logout killsumapps.pl
if ( -e $logout_trigger_file) {
  unlink $logout_trigger_file;
  print "Found $logout_trigger_file\n" if $debug;
  my $display_cancel_message = 0;
  if ( ! true_var( $DONT_FORCE_LOGOUT ) ) {
    my $kill_flag = 0;
    my $counter = 60;
    while ( ! -e $logout_hook_running and ! -e $logout_hook_finished ) {
      print "$counter: ! -e $logout_hook_running or ! -e $logout_hook_finished\n" if $debug;
      if ( $counter < 0 ) {
        print "$killsumapps, getUsername()\n" if $debug;
        system $killsumapps, getUsername();
        sleep 1;
        $launchd_delay--;
        #print "/usr/bin/killall loginwindow\n" if $debug;
        #system "/usr/bin/killall", "loginwindow";
        print "/sbin/reboot\n" if $debug;
        system "/sbin/reboot" if ! $debug;
        last;
      }
      if ( $counter < 30 and $counter % 5 == 0 and $counter != 0 ) {
        system "/usr/local/bin/BigHonkingText This computer will reboot in $counter seconds &";
        $display_cancel_message = 1;
      }
      sleep 1;
      $launchd_delay--;
      $counter--;
    }
    if ( $display_cancel_message ) {
      system "/usr/local/bin/BigHonkingText Restart canceled &";
    }
    print "-e $logout_hook_running or -e $logout_hook_finished\n" if $debug;
  }
  exit;
}

print "Found Nothing\n" if $debug;
$launchd_delay = 0 if $launchd_delay < 1;
sleep $launchd_delay; # wait 10 seconds or launchd will complain

exit 0;
