#!/usr/bin/perl -w
#
# Copyright (c) 2009 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
#

use lib "/Library/Xhooks/Modules";
require "xhooks/lib/config.pl";

# Check to see if I even have a built-in iSight
if ( `system_profiler SPUSBDataType | grep iSight | wc -l` < 1 ) {
  kill_self();
}

if ( ! nonempty_var ( $WEBCAM_UPLOAD_SERVER ) or ! nonempty_var ( $WEBCAM_WAIT_SECONDS ) ) {
  kill_self();
}

my $my_ip = get_ip();

my $AddTextToImage = "/usr/local/bin/AddTextToImage";
my $isightcapture = "/usr/local/bin/isightcapture";
my $prefFile = "/Library/Preferences/Xhooks/edu.utah.scl.webcam.plist";
my $image_save_path = "/tmp/$my_ip.png";

my $debug = ( defined $ARGV[0] ) ? 1 : 0;

while (1) {
  my $date = `date`;
  if ( ! $debug ) {
    unlink $image_save_path if -e $image_save_path;
    system "$isightcapture", $image_save_path;
    if ( -e $image_save_path ) {
      system "$AddTextToImage", "-i", $image_save_path, "-o", $image_save_path, "-s12", "-x9", "-y9", "-r0", "-g0", "-b0", "-d1", "$date";
      system "$AddTextToImage", "-i", $image_save_path, "-o", $image_save_path, "-s12", "-x9", "-y11`", "-r0", "-g0", "-b0", "-d1", "$date";
      system "$AddTextToImage", "-i", $image_save_path, "-o", $image_save_path, "-s12", "-x11", "-y9", "-r0", "-g0", "-b0", "-d1", "$date";
      system "$AddTextToImage", "-i", $image_save_path, "-o", $image_save_path, "-s12", "-x11", "-y11", "-r0", "-g0", "-b0", "-d1", "$date";
      system "$AddTextToImage", "-i", $image_save_path, "-o", $image_save_path, "-s12", "-x10", "-y10", "-d10", "$date";
    } else {
      print "Couldn't create image file!\n";
    }
  } else {
    system "echo debug > \"$image_save_path\"";
  }
  if ( -e $image_save_path ) {
    my $authentication = "";
    if ( nonempty_var ( $WEBCAM_UPLOAD_USERNAME ) and nonempty_var ( $WEBCAM_UPLOAD_PASSWORD ) ) {
      print "Using Authentication\n" if $debug;
      $authentication = "-u $WEBCAM_UPLOAD_USERNAME:$WEBCAM_UPLOAD_PASSWORD";
    }
    print "curl $authentication -F file=\@\"$image_save_path\" \"$WEBCAM_UPLOAD_SERVER\" 2> /dev/null\n" if $debug;
    my $result = `curl $authentication -F file=\@\"$image_save_path\" \"$WEBCAM_UPLOAD_SERVER\" 2> /dev/null`;

    print $result if $debug;
    unlink $image_save_path;
  }
  sleep $WEBCAM_WAIT_SECONDS;
}

sub kill_self {
  # I shouldn't run, unload myself
  system "launchctl unload /Library/LaunchAgents/edu.utah.scl.webcam.plist" if -e "/Library/LaunchAgents/edu.utah.scl.webcam.plist";
  exit;
}
