#################################################################################
# config.pl
#
# Xhooks developer configuration and shared functions for perl scripts
#
# Copyright (c) 2002 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
#
################################################################################

if ( -f "/Library/Preferences/Xhooks/edu.utah.scl.radmind_xhooks_conf.perl" ) {
  use lib "/Library/Preferences/Xhooks";
  require "edu.utah.scl.radmind_xhooks_conf.perl";
}

#######################
####
#### Eventually all of the lower case variables below should be replaced in each script 
#### with the upper case version that comes from the command files.  When they are replaced
#### they should be removed from this file.
####
#######################

#######################
# Set account info
$kioskusername = ( defined $AUTOLOGIN_USER_NAME and $AUTOLOGIN_USER_NAME ne "" ) ? $AUTOLOGIN_USER_NAME : "kiosk";

$adminusername = ( defined $ADMIN_USER_NAME and $ADMIN_USER_NAME ne "" ) ? $ADMIN_USER_NAME : "mac";
$adminUserHomeFolder = ( defined $ADMIN_HOME_DIR and $ADMIN_HOME_DIR ne "" ) ? $ADMIN_HOME_DIR : "/Users/mac";

$template_name = ( defined $TEMPLATE_USER_NAME and $TEMPLATE_USER_NAME ne "" ) ? $TEMPLATE_USER_NAME : "template";
$template_homefolder = ( defined $TEMPLATE_HOME_DIR and $TEMPLATE_HOME_DIR ne "" ) ? $TEMPLATE_HOME_DIR : "/Users/template";

$enduser_group = ( defined $GROUP and $GROUP ne "" ) ? $GROUP : "staff";

$maintenanceusername = ( defined $RADMIND_USER_NAME and $RADMIND_USER_NAME ne "" ) ? $RADMIND_USER_NAME : "radmind";

$userHomeFolder = $LOGIN_HOME_DIR;

################################################################################

# If a user is logged in, display a warning and wait this ammount of minutes before rebooting.
$restart_warning_minutes_if_user_logged_in = 5;

################################################################################
# Xhooks folder and contents

$xhooks_folder = "/Library/Xhooks";

# locations that need to be wiped often
$homeFolderBackups = "/Library/Preferences/Xhooks/Caches/edu.utah.scl.home_folder/homes"; # Where home folders are stored
$global_home_folder_lost_and_found = "/Library/Preferences/Xhooks/Caches/edu.utah.scl.home_folder/lost_and_found";
$writable_caches_folder = "/Library/Preferences/Xhooks/Caches/edu.utah.scl.replicate";

$remote_logger_script = "/Library/Xhooks/Modules/edu.utah.scl.report/report_to_master.sh";

$pathToiHook = "/usr/local/bin/iHook.app/Contents/MacOS/iHook";

$reboot_required = "/tmp/reboot_required";
$use_shadow_server = "/Library/Preferences/Xhooks/triggerfiles/use_radmind_shadow";

# Status files trigger files (scripts create/delete these and use them to track stuff)
$maintenance_lastrun = "/var/log/maintenance_lastrun";
$radmind_error_file = "/var/log/radmind_error.log";
$error_message_file = "/var/log/status_error.log";

$login_name_trigger = ".username";

use lib "/Library/Xhooks/Modules";
require "xhooks/lib/logger.pl";
require "xhooks/lib/common.pl";

# debug, info, notice, warn, err, crit, alert, emerg
# To see log messages type:
# sudo syslog -c syslogd -d
# http://developer.apple.com/documentation/Darwin/Reference/ManPages/man1/syslog.1.html#//apple_ref/doc/man/1/syslog

1;
