#!/usr/bin/perl

################################################################################
# Copyright (c) 2008 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
################################################################################

use Foundation;
use lib "/Library/Xhooks/Modules/";
require "xhooks/lib/perlplist.pl";

#           minute        0-59
#           hour          0-23
#           day of month  1-31
#           month         1-12
#           day of week   0-7 (0 or 7 is Sun)


sub create_time_interval_launchd {
  my ( $identifier, $minute, $hour, $day, $month, $weekday, @progArgs ) = @_;

  my %times = ();
  $times{'Minute'} = cocoaInt( $minute ) if $minute ne "" and $minute ne "*" and $minute >= 0 and $minute <= 59;
  $times{'Hour'} = cocoaInt( $hour ) if $hour ne "" and $hour ne "*" and $hour >= 0 and $hour <= 23;
  $times{'Day'} = cocoaInt( $day ) if $day ne "" and $day ne "*" and $day >= 1 and $day <= 31;
  $times{'Month'} = cocoaInt( $month ) if $month ne "" and $month ne "*" and $month >= 1 and $month <= 12;
  $times{'Weekday'} = cocoaInt( $weekday ) if $weekday ne "" and $weekday ne "*" and $weekday >= 0 and $weekday <= 7;

  my %dict = (
    ProgramArguments		=> \@progArgs,
    Label					=> $identifier,
    StartCalendarInterval	=> \%times
  );

  my $save_file="/Library/LaunchDaemons/$identifier.plist";

  saveDefaults( cocoaDictFromPerlHash( %dict ), $save_file );
  entman_logger ( "log drawer", "Saved \"$hour:$minute $radmind_days, $reboot_days\" - to $save_file" );

}
